from __future__ import annotations

import typing

from digitalhub.entities.function._base.entity import Function

if typing.TYPE_CHECKING:
    from digitalhub.entities._base.entity.metadata import Metadata

    from digitalhub_runtime_modelserve.entities.function.modelserve.spec import FunctionSpecModelserve
    from digitalhub_runtime_modelserve.entities.function.modelserve.status import FunctionStatusModelserve


class FunctionModelserve(Function):
    """
    FunctionModelserve class.
    """

    def __init__(
        self,
        project: str,
        name: str,
        uuid: str,
        kind: str,
        metadata: Metadata,
        spec: FunctionSpecModelserve,
        status: FunctionStatusModelserve,
        user: str | None = None,
    ) -> None:
        super().__init__(project, name, uuid, kind, metadata, spec, status, user)

        self.spec: FunctionSpecModelserve
        self.status: FunctionStatusModelserve
